"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
price.proto

Functions and messages supporting an e-commerce
workflow for things like invoices, shipping labels,
etc.
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import kerfed.protos.common.v1.address_pb2
import kerfed.protos.common.v1.config_pb2
import kerfed.protos.common.v1.fab_pb2
import kerfed.protos.common.v1.machine_pb2
import kerfed.protos.common.v1.money_pb2
import kerfed.protos.common.v1.outcome_pb2
import kerfed.protos.common.v1.stock_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class Operation(google.protobuf.message.Message):
    """An operation which"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    OPERATION_ID_FIELD_NUMBER: builtins.int
    PRICE_FIELD_NUMBER: builtins.int
    IS_COMBINABLE_FIELD_NUMBER: builtins.int
    DURATION_FIELD_NUMBER: builtins.int
    UTILIZATION_FIELD_NUMBER: builtins.int
    NOTE_FIELD_NUMBER: builtins.int
    operation_id: builtins.str
    """if we were tracking these in an ERP system"""
    @property
    def price(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """how much does this component of the price cost?"""
    is_combinable: builtins.bool
    """Is this a "combinable setup"
    if this part of the price needs to be filled in later
    for example setups will be combined at the bottom of
    the invoice rather than listed as a subcomponent here
    if true: price represents ceil( sum(utilization) ) * price
    """
    duration: builtins.float
    """how long did this operation take in seconds
    if `combine=True` this is the length of 1.0 utilization
    """
    utilization: builtins.float
    """how much of this setup does ONE part consume
    ONLY used if `combine=True`
    """
    note: builtins.str
    """a user-facing note about this price
    i.e. "Amada 4kW Fiber Laser, 10 "
    """
    def __init__(
        self,
        *,
        operation_id: builtins.str = ...,
        price: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        is_combinable: builtins.bool = ...,
        duration: builtins.float = ...,
        utilization: builtins.float = ...,
        note: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["price", b"price"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["duration", b"duration", "is_combinable", b"is_combinable", "note", b"note", "operation_id", b"operation_id", "price", b"price", "utilization", b"utilization"]) -> None: ...

global___Operation = Operation

@typing_extensions.final
class LinePrice(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LINE_ID_FIELD_NUMBER: builtins.int
    GEOM_ID_FIELD_NUMBER: builtins.int
    METHOD_ID_FIELD_NUMBER: builtins.int
    SHOP_ID_FIELD_NUMBER: builtins.int
    ADDRESS_ID_FIELD_NUMBER: builtins.int
    PRICE_FIELD_NUMBER: builtins.int
    QUANTITY_FIELD_NUMBER: builtins.int
    MASS_FIELD_NUMBER: builtins.int
    EXTENTS_FIELD_NUMBER: builtins.int
    STOCK_FIELD_NUMBER: builtins.int
    OPERATIONS_FIELD_NUMBER: builtins.int
    OUTCOME_FIELD_NUMBER: builtins.int
    line_id: builtins.str
    """the unique identifier for the part this price is for"""
    geom_id: builtins.str
    """the geometry this price was generated for"""
    method_id: builtins.str
    """the fabrication method this is valid for, i.e. `flat`"""
    shop_id: builtins.str
    """what vendor is producing this part"""
    address_id: builtins.str
    """where exactly is this part being produced"""
    @property
    def price(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """the *unit* price of the part"""
    quantity: builtins.int
    """this price is *only valid at a specific quantity.*"""
    mass: builtins.float
    """how much does the *each* part weigh in *kilograms*"""
    @property
    def extents(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]:
        """how large is *each* part in *meters*"""
    @property
    def stock(self) -> kerfed.protos.common.v1.stock_pb2.Stock:
        """the raw material input `stock` the part was made from."""
    @property
    def operations(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Operation]:
        """if a part consists of "buy metal sheet, cut on laser, ..."
        return a list of these operations which can be displayed
        to the user as an "itemized" price or can be used when
        released to manufacturing as a "todo list".
        ERP systems sometimes have the list
        of operations with a signature and barcode next to each op
        and we could do a thing with a QR code if desired.
        """
    @property
    def outcome(self) -> kerfed.protos.common.v1.outcome_pb2.Outcome:
        """If this price had an error list here."""
    def __init__(
        self,
        *,
        line_id: builtins.str = ...,
        geom_id: builtins.str = ...,
        method_id: builtins.str = ...,
        shop_id: builtins.str = ...,
        address_id: builtins.str = ...,
        price: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        quantity: builtins.int = ...,
        mass: builtins.float = ...,
        extents: collections.abc.Iterable[builtins.float] | None = ...,
        stock: kerfed.protos.common.v1.stock_pb2.Stock | None = ...,
        operations: collections.abc.Iterable[global___Operation] | None = ...,
        outcome: kerfed.protos.common.v1.outcome_pb2.Outcome | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["outcome", b"outcome", "price", b"price", "stock", b"stock"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["address_id", b"address_id", "extents", b"extents", "geom_id", b"geom_id", "line_id", b"line_id", "mass", b"mass", "method_id", b"method_id", "operations", b"operations", "outcome", b"outcome", "price", b"price", "quantity", b"quantity", "shop_id", b"shop_id", "stock", b"stock"]) -> None: ...

global___LinePrice = LinePrice

@typing_extensions.final
class LineSpec(google.protobuf.message.Message):
    """a fully configured part ready to be released to manufacturing"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LINE_ID_FIELD_NUMBER: builtins.int
    GEOM_ID_FIELD_NUMBER: builtins.int
    SHOP_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    FAB_FIELD_NUMBER: builtins.int
    CONFIG_FIELD_NUMBER: builtins.int
    line_id: builtins.str
    """globally unique identifier for this part"""
    geom_id: builtins.str
    """locally unique identifier which indicates
    which geometry in the local scenes this is
    """
    shop_id: builtins.str
    """which shop is assigned to make this part"""
    name: builtins.str
    """nicer display name"""
    @property
    def fab(self) -> kerfed.protos.common.v1.fab_pb2.PartFabrication:
        """fabrication data from analysis pipeline"""
    @property
    def config(self) -> kerfed.protos.common.v1.config_pb2.PartConfiguration:
        """full configuration that can be priced"""
    def __init__(
        self,
        *,
        line_id: builtins.str = ...,
        geom_id: builtins.str = ...,
        shop_id: builtins.str = ...,
        name: builtins.str = ...,
        fab: kerfed.protos.common.v1.fab_pb2.PartFabrication | None = ...,
        config: kerfed.protos.common.v1.config_pb2.PartConfiguration | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["config", b"config", "fab", b"fab"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["config", b"config", "fab", b"fab", "geom_id", b"geom_id", "line_id", b"line_id", "name", b"name", "shop_id", b"shop_id"]) -> None: ...

global___LineSpec = LineSpec

@typing_extensions.final
class OrderPrice(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TOTAL_FIELD_NUMBER: builtins.int
    LINES_FIELD_NUMBER: builtins.int
    SETUPS_FIELD_NUMBER: builtins.int
    SHIPPING_FIELD_NUMBER: builtins.int
    TAXES_FIELD_NUMBER: builtins.int
    DISCOUNT_FIELD_NUMBER: builtins.int
    @property
    def total(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """the sum price the customer was billed"""
    @property
    def lines(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """the sum price of all parts in this order"""
    @property
    def setups(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """the sum of all setups after combining"""
    @property
    def shipping(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """total shipping cost billed to customer"""
    @property
    def taxes(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """taxes billed to customer"""
    @property
    def discount(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """discount, usually negative: note that it is signed"""
    def __init__(
        self,
        *,
        total: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        lines: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        setups: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        shipping: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        taxes: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        discount: kerfed.protos.common.v1.money_pb2.Money | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["discount", b"discount", "lines", b"lines", "setups", b"setups", "shipping", b"shipping", "taxes", b"taxes", "total", b"total"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["discount", b"discount", "lines", b"lines", "setups", b"setups", "shipping", b"shipping", "taxes", b"taxes", "total", b"total"]) -> None: ...

global___OrderPrice = OrderPrice

@typing_extensions.final
class PriceMetadata(google.protobuf.message.Message):
    """Contains mappings of IDs to metadata used for pricing."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    STOCK_FIELD_NUMBER: builtins.int
    MACHINES_FIELD_NUMBER: builtins.int
    ADDRESSES_FIELD_NUMBER: builtins.int
    @property
    def stock(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.stock_pb2.Stock]:
        """The available stock materials that can be used by the
        configured parts.
        """
    @property
    def machines(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.machine_pb2.Machine]:
        """The available machines that can be used to cut the parts."""
    @property
    def addresses(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.address_pb2.PostalAddress]:
        """what are the facilities that are mailing stuff."""
    def __init__(
        self,
        *,
        stock: collections.abc.Iterable[kerfed.protos.common.v1.stock_pb2.Stock] | None = ...,
        machines: collections.abc.Iterable[kerfed.protos.common.v1.machine_pb2.Machine] | None = ...,
        addresses: collections.abc.Iterable[kerfed.protos.common.v1.address_pb2.PostalAddress] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["addresses", b"addresses", "machines", b"machines", "stock", b"stock"]) -> None: ...

global___PriceMetadata = PriceMetadata
